// @ myth - common - cfront.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk
//
// Kludge City
// 
// Or how to defeat cfront

// @@ begin

#ifndef CFRONT_HEADER
#define CFRONT_HEADER

// @@ keyword

#define CONST_MEMBER

// The c preprocessor does not know about c++ comments, so it will
// still do macro expansion within the comments. This migth cause some
// wrong error messages, if the macro have arguments.

#ifdef minor
#undef minor			// I don't need any minor device numbers.
#endif minor

// @@ overload

overload abs;
overload min;
overload max;
overload sqr;

// @@ include

struct hostent;			// ARRGGGHHHHHH!!!!!
overload gethostbyname;		// And he said: kludge...
extern hostent* gethostbyname(const char*);
// <netdb.h> claim ghbn has no arguments!!!

#include <stdlib.h>
// Avoid  "include of </usr/include/...> might be unportable" warning
#include </tmp/../usr/include/fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/time.h>

// @@ extern


overload tputs;

extern int socket(int, int, int);
extern int bind(int, void*, int);
extern int connect(int, void*, int);
extern int accept(int, void*, int*);
extern int listen(int, int);
extern int shutdown(int, int);
extern int gethostname(char*, int);
extern int select(int, int*, int*, int*, timeval*);
extern int getdtablesize();

extern char* tgoto(const char* cm, int destcol, int destline);
extern int tgetent(char* bp, const char* name);
extern int tgetnum(const char* id);
extern bool tgetflag(const char* id);
extern char* tgetstr(const char* id, char** area);
extern int usleep(unsigned);
extern int fsync(int fd);
extern void bcopy(void*, void*, int);
extern int tputs(const char*, int, void (*pfVC)(char));

// @@ long max(long a, long b)

inline long max(long a, long b)
{ return (a > b) ? a : b; }

// @@ long min(long a, long b)

inline long min(long a, long b)
{ return (a < b) ? a : b; }

// @@ long abs(long x)

inline long abs(long x)
{ return x < 0 ? -x : x; }

// @@ long sqr(long x)

inline long sqr(long x)
{ return x * x; }

// @@ typedef

typedef void (*TPUTS_FUN)(char);


// @@ end

#endif CFRONT_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
